# portvalue.py

def read_portfolio(filename):
    stocks = []
    for line in open(filename):
         fields = line.split()
         record = { 'name' : fields[0],
                    'shares' : int(fields[1]),
                    'price' : float(fields[2]) }
         stocks.append(record)
    return stocks

# Read prices into a dictionary
def read_prices(filename):
    prices = { }
    for line in open(filename):
         fields = line.split(',')
         prices[fields[0]] = float(fields[1])
    return prices

# Calculate current value of a portfolio
def portfolio_value(stocks,prices):
    return sum([s['shares']*prices[s['name']] 
                  for s in stocks])    

# Calculate the value of Dave's portfolio

stocks = read_portfolio("portfolio.dat")
prices = read_prices("prices.dat")
value  = portfolio_value(stocks,prices)

print "Current value", value
